local vec3 = require "vec3"
local vec4 = require "vec4"

local oppie_transf = { }

function oppie_transf.new(col0, col1, col2, col3)
	return {
		col0.x, col0.y, col0.z, col0.w,
		col1.x, col1.y, col1.z, col1.w,
		col2.x, col2.y, col2.z, col2.w,
		col3.x, col3.y, col3.z, col3.w
	}
end


function oppie_transf.rotScale(scaleX, scaleY, scaleZ, rotZ, transl)
	local sz = math.sin(rotZ)
	local cz = math.cos(rotZ)

	return oppie_transf.new(
		vec4.new(scaleX * cz, scaleX * sz, .0, .0),
		vec4.new(scaleY * -sz, scaleY * cz, .0, .0),
		vec4.new(.0, .0, scaleZ, .0),
		vec4.new(transl.x, transl.y, transl.z, 1.0))
end

return oppie_transf